// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase Columna

#ifndef SUDOKU_CAJA
#define SUDOKU_CAJA

#include "casilla.h"
#include "unico.h"
#include "pareja.h"

class Tablero;

class Caja {
    private:
    Casilla *cas[9];
    int punteroFila[3][9];
    int punteroColumna[3][9];

    public:
    Caja();
    void Iniciar(Tablero &t, int c);
    bool Presente(int n);
    Casilla *Cas(int i) { return cas[i]; }
    Casilla **GetCasillas() { return cas; }
    //
    void Criba();
    int CuentaPosibles();
    int PrimeroPosible();
    int SegundoPosible(int p);
    int TerceroPosible(int t);
    bool AsignaPunteroFila(int f, int v, int n);
    bool AsignaPunteroColumna(int c, int v, int n);
    bool PunteroFila(int f, int v) const { return punteroFila[f][v-1]; }
    bool PunteroColumna(int c, int v) const { return punteroColumna[c][v-1]; }
    void AsignarLapizUnicos();
    Unico CandidatoUnico();
    void DesmarcaLapiz(int v);
    Unico UnicaCasillaConCandidato();
    // XY-Wing
    Casilla *BuscaAla2MenosFila(Casilla *pivote, Casilla *ala1);
    Casilla *BuscaAla2MenosColumna(Casilla *pivote, Casilla *ala1);
    int BuscarMarcas(const MarcasLapiz &m);
    // Rectngulos vacos
    int RectanguloVacio(int v);
    // Hilo de cometa
    Pareja DobleCandidato(int v);
};
#endif // SUDOKU_CAJA
