// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase Casilla

#ifndef SUDOKU_CASILLA
#define SUDOKU_CASILLA

#include <windows.h>
#include "marcaslapiz.h"

class Casilla {
    private:
    int fila,columna,caja,pos;
    int valor;
    bool posible;
    bool inicial;
    bool resaltar;
    bool amarillo;
    bool naranja;
    MarcasLapiz marcas;

    public:
    Casilla() : fila(), columna(0), valor(0), inicial(false), marcas(0) {}
    Casilla(int f, int c, int v, bool ini);
    int Valor() const { return valor; }
    void Asignar(int v);
    int Fila() const { return fila; }
    int Columna() const { return columna; }
    int Caja() const { return caja; }
    int PosEnCaja() const { return pos; }
    bool Posible() const { return posible; }
    void Resaltar(bool r=true) { resaltar = r; }
    void Amarillo(bool a=true) { amarillo = a; }
    void Naranja(bool n=true) { naranja = n; }
    void MarcaPosible( bool p=true ) { posible = p; }
    void MarcaNoPosible() { posible = false; }
    MarcasLapiz &Lapiz() { return marcas; }
    void Mostrar();
};
#endif // SUDOKU_CASILLA
