// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase Columna

#ifndef SUDOKU_COLUMNA
#define SUDOKU_COLUMNA

#include "casilla.h"
#include "unico.h"
#include "pareja.h"
#include "marcascasillas.h"

class Tablero;

class Columna {
    private:
    Casilla *cas[9];

    public:
    Columna() { for(int i=0; i < 9; i++) cas[i] = NULL; }
    void Iniciar(Tablero &t, int f);
    bool Presente(int n);
    Casilla *Cas(int i) { return cas[i]; }
    Casilla **GetCasillas() { return cas; }
    //
    void Criba();
    void CribaMenosCaja(int f);
    Unico CandidatoUnico();
    int UnicoPosible();
    void DesmarcaLapiz(int v);
    void DesmarcaLapizMenosCaja(int k, int v);
    Unico UnicaCasillaConCandidato();
    // XY_Wing
    Casilla *BuscaAla1MenosCaja(Casilla *pivote, int f1=0);
    Casilla *BuscaAla2MenosCaja(Casilla *pivote, Casilla *ala1);
    // X-Wing
    Pareja DobleCandidato(int v);
    // X-Wing-alas
    Casilla *DobleCandidatoYMas(Pareja par, int v);
    // SwordFish
    int CuentaCandidato(int v);
    int BuscarMarcas(const MarcasLapiz &m);
    MarcasCasillas Marcas(int v);
};
#endif // SUDOKU_COLUMNA
