// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase Desnudo

#ifndef SUDOKU_DESNUDO
#define SUDOKU_DESNUDO

#include "casilla.h"

// Pares y trios desnudos
class Desnudo {
    private:
    int elementos;
    bool paraBorrar;
    Casilla *cas[3];
    int val[3];
    public:
    Desnudo(int n=0) : elementos(n), paraBorrar(false) {
        cas[0] = cas[1] = cas[2] = NULL;
    }
    void AsignarCas(int pos, Casilla *c) { cas[pos] = c; }
    void AsignarVal(int pos, int v) { val[pos] = v; }
    bool Par() const { return elementos==2; }
    bool Trio() const { return elementos==3; }
    Casilla *Cas(int c) { return cas[c]; }
    int Val(int n) { return val[n]; }
    bool operator<(const Desnudo &d) const;
    bool operator==(const Desnudo &d) const;
    void MarcarParaBorrar() { paraBorrar = true; }
    void MarcarParaNoBorrar() { paraBorrar = false; }
    bool MarcadoParaBorrar() const { return paraBorrar; }

    int MismaFila();
    int MismaColumna();
    int MismaCaja();
};
#endif // SUDOKU_DESNUDO
