// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase Grafo
//
// Se usa para detectar parejas y trios ocultos

#ifndef SUDOKU_GRAFO
#define SUDOKU_GRAFO

#include "casilla.h"
#include "marcaslapiz.h"

class Grafo {
    private:
    int grupo;
    Casilla **cas;
    int nAristas[9];
    bool arista[9][9];
    bool nodo[9];
    MarcasLapiz marcas;
    int valor[9];
    int nod[9];

    public:
    Grafo(int gr) : grupo(gr) {}
    void IniciarMarcas(Casilla **c) { cas = c; }
    void AsignarAristas();
    void EliminarAristasUnicas();
    bool BuscarGrupo();
    void EliminaGrupo();
    int Nodo(int n);
    int Valor(int n);
    bool Contiene(int p);
    // Auxiliares para LOG
    char *Casillas();
    char *Valores();
};

#endif // SUDOKU_GRAFO
