// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Definicin de la clase MarcasCasillas

#include "marcascasillas.h"

void MarcasCasillas::AsignaCasilla(int c) {
    casillas |= 1<<c;
}

int MarcasCasillas::CuentaCasillas() {
    int cuenta=0;
    for(int c=0; c<9; c++) if(ContieneCasilla(c)) cuenta++;
    return cuenta;
}

bool MarcasCasillas::ContieneCasilla(int c) {
    return (casillas & 1<<c);
}

MarcasCasillas MarcasCasillas::operator+(const MarcasCasillas &m1) {
    MarcasCasillas res(0);
    res.casillas = this->casillas | m1.casillas;
    return res;
}

MarcasCasillas MarcasCasillas::operator~() {
    MarcasCasillas res(0);
    res.casillas = ~this->casillas;
    return res;
}

MarcasCasillas MarcasCasillas::operator&(const MarcasCasillas &m1) {
    MarcasCasillas res(0);
    res.casillas = this->casillas & m1.casillas;
    return res;
}

int MarcasCasillas::Cajas() {
    int retval = 0;

    if(casillas & 0x1c0) retval += 4;
    if(casillas & 0x38) retval += 2;
    if(casillas & 0x7) retval += 1;
    return retval;
}
 int MarcasCasillas::Casilla() {
    for(int c=1; c<=9; c++) if(ContieneCasilla(c)) return c;
    return -1;
}

void MarcasCasillas::MascaraCaja(int k) {
    if(k <= 2)
        casillas &= (7 << k*3);
}
