// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase MarcasLapiz

#ifndef SUDOKU_MARCASCASILLAS
#define SUDOKU_MARCASCASILLAS

class MarcasCasillas {
    private:
    unsigned int casillas;

    public:
    MarcasCasillas(unsigned int c=0) : casillas(c) {}
    MarcasCasillas(const MarcasCasillas &m) { casillas = m.casillas; }
    void Borra() { casillas = 0; }
    void AsignaCasilla(int c);
    int CuentaCasillas();
    bool ContieneCasilla(int c);
    MarcasCasillas &operator=(const MarcasCasillas &m1) { casillas = m1.casillas; return *this; };
    MarcasCasillas operator+(const MarcasCasillas &m1);
    MarcasCasillas operator~();
    MarcasCasillas operator&(const MarcasCasillas &m1);
    int Cajas();
    int Casilla();
    void MascaraCaja(int k);
};
#endif // SUDOKU_MARCASCASILLAS

