// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase MarcasLapiz

#ifndef SUDOKU_MARCASLAPIZ
#define SUDOKU_MARCASLAPIZ

class MarcasLapiz {
    private:
    unsigned int lapiz;

    public:
    MarcasLapiz(unsigned int l=0) : lapiz(l) {}
    MarcasLapiz(const MarcasLapiz &m) { lapiz = m.lapiz; }
    bool AsignaMarca(int v);
    bool EliminaMarca(int v);
    int CuentaMarcas();
    bool ContieneMarca(int v);
    MarcasLapiz &operator=(const MarcasLapiz &m1) { lapiz = m1.lapiz; return *this; };
    MarcasLapiz operator+(const MarcasLapiz &m1);
    MarcasLapiz operator^(const MarcasLapiz &m1);
    MarcasLapiz operator-(const MarcasLapiz &m1);
    bool operator==(const MarcasLapiz &m1) { return this->lapiz == m1.lapiz; }
    bool Quitar(const MarcasLapiz &m1);
    char* Valores();
    int Valor(); // Valor si lapiz solo tiene una marca
    int ValorMarca(int n);
};

#endif // SUDOKU_MARCASLAPIZ
