// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase Pareja

#ifndef SUDOKU_PAREJA
#define SUDOKU_PAREJA

#include "casilla.h"

class Pareja {
private:
    Casilla *cas[2];

public:
    Pareja() { cas[0] = cas[1] = NULL; }
    Casilla *Cas(int c) { return cas[c]; }
    void Asigna(int p, Casilla *c) { if(p < 2) cas[p] = c; };
    bool MismaCaja() { return cas[0]->Caja() == cas[1]->Caja(); }
    bool MismaFila() { return cas[0]->Fila() == cas[1]->Fila(); }
    bool MismaColumna() { return cas[0]->Columna() == cas[1]->Columna(); }
};

#endif // SUDOKU_PAREJA
