// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Definicin de la clase Puntero

#include "puntero.h"

// Operadores necesarios para insertar nodos Puntero en lista
bool Puntero::operator<(const Puntero &d) const {
    if(elementos > d.elementos) return false;
    if(elementos < d.elementos) return true;
    if(cas[0]->Fila() < d.cas[0]->Fila()) return true;
    if(cas[1]->Fila() < d.cas[1]->Fila()) return true;
    if(elementos>2 && cas[2]->Fila() < d.cas[2]->Fila()) return true;
    if(cas[0]->Columna() < d.cas[0]->Columna()) return true;
    if(cas[1]->Columna() < d.cas[1]->Columna()) return true;
    if(elementos>2 && cas[2]->Columna() < d.cas[2]->Columna()) return true;
    return false;
}
bool Puntero::operator==(const Puntero &d) const {
    if(elementos != d.elementos) return false;
    if(cas[0]->Fila() != d.cas[0]->Fila()) return false;
    if(cas[1]->Fila() != d.cas[1]->Fila()) return false;
    if(elementos>2 && cas[2]->Fila() != d.cas[2]->Fila()) return false;
    if(cas[0]->Columna() != d.cas[0]->Columna()) return false;
    if(cas[1]->Columna() != d.cas[1]->Columna()) return false;
    if(elementos>2 && cas[2]->Columna() != d.cas[2]->Columna()) return false;
    return true;
}

// Devuelve el nmero de fila si el par o trio est en una misma fila, -1 si no
int Puntero::MismaFila() {
    if(cas[0]->Fila() == cas[1]->Fila() && Par()) return cas[0]->Fila();
    if(cas[0]->Fila() == cas[1]->Fila() &&
       cas[0]->Fila() == cas[2]->Fila() && Trio()) return cas[0]->Fila();
    return -1;
}

// Devuelve el nmero de columna si el par o trio est en una misma columna, -1 si no
int Puntero::MismaColumna() {
    if(cas[0]->Columna() == cas[1]->Columna() && Par()) return cas[0]->Columna();
    if(cas[0]->Columna() == cas[1]->Columna() &&
       cas[0]->Columna() == cas[2]->Columna() && Trio()) return cas[0]->Columna();
    return -1;
}

// Devuelve el nmero de caja si el par o trio est en una misma caja, -1 si no
int Puntero::MismaCaja() {
    if(cas[0]->Caja() == cas[1]->Caja() && Par()) return cas[0]->Caja();
    if(cas[0]->Caja() == cas[1]->Caja() &&
       cas[0]->Caja() == cas[2]->Caja() && Trio()) return cas[0]->Caja();
    return -1;
}

