// Sudokus con Clase
// Resolucin de sudokus con tcnicas reales
// (C) 2022 Salvador Pozo
// Con Clase https://conclase.net
//
// Declaracin de la clase Puntero

#ifndef SUDOKU_PUNTERO
#define SUDOKU_PUNTERO

#include "casilla.h"

// Pares y trios puntero
class Puntero {
    private:
    int elementos;
    Casilla *cas[3];
    int val;
    public:
    Puntero(int n=0) : elementos(n) {
        cas[0] = cas[1] = cas[2] = NULL;
    }
    void AsignarCas(int pos, Casilla *c) { cas[pos] = c; }
    void AsignarVal(int v) { val = v; }
    bool Par() const { return elementos==2; }
    bool Trio() const { return elementos==3; }
    Casilla *Cas(int c) { return cas[c]; }
    int Val() { return val; }
    bool operator<(const Puntero &d) const;
    bool operator==(const Puntero &d) const;

    int MismaFila();
    int MismaColumna();
    int MismaCaja();
};
#endif // SUDOKU_PUNTERO
